   <div>
    <p>Idemo na sljedeći logički sklop.
       Na slici u nastavku prikazan je digitalni sklop s dva ulaza (<i>A</i> i <i>B</i>) i jednim izlazom (<i>f</i>).
       Na ulaze tog sklopa redom se dovode sve kombinacije logičkih nula i logičkih jedinica. Za svaku konkretnu 
       kombinaciju na ulazu, prikazano je i što sklop generira na izlazu.
    </p>
    <p>Desno od sklopa prikazana je tablica istinitosti kojom želimo opisati ponašanje promatranog digitalnog sklopa.
       Prva dva stupca sadrže vrijednosti ulaza <i>A</i> i <i>B</i>. Za konkretnu kombinaciju ulaza u svakom retku treći
       stupac tablice (stupac označen s <i>f</i>) treba sadržavati vrijednost koju sklop generira na svojem izlazu za
       tu kombinaciju ulaza (kažemo još za takvu <i>pobudu</i>). Vrijednosti u stupcu <i>f</i> možete mijenjati klikom
       miša na odgovarajuću ćeliju.
    </p>
   </div>
   <div class="mlQuestionText">
    <p>Vaš je zadatak da pogledate što sklop generira za različite kombinacije ulaza te na temelju toga popunite 
       stupac <i>f</i> prikazane tablice. Kad ste gotovi, pritisnite gumb za nastavak.
    </p>

    <canvas id="myCanvas" width="600" height="170"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 2,
        hots: []
      };

      var konfiguracija = @#raw-text#(jsinitdata);
      state.elems = konfiguracija.elems;
      state.userInput = konfiguracija.userInput;

      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            var u = state.userInput[h.row];
            if(u==-1) { u = 0; } else { u = 1-u; }
            state.userInput[h.row] = u;
            draw(canvas, context, state);
            break;
          }
        }
      }, false);

      function draw(canvas, context, state) {
        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw circuit...

        var cloff = 100; var ctoff = 40; var cvertOut = 20; var cvertBetween = 50; var choriz = 70; var connector = 20;

        var cheight = 2*cvertOut + (state.vars-1)*cvertBetween;

        context.beginPath();
        context.strokeStyle = '#000000';
        for(var v = 0; v < state.vars; v++) {
          context.moveTo(cloff, ctoff+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+cvertOut+v*cvertBetween);
        }
        context.moveTo(cloff + connector + choriz, ctoff+cheight/2);
        context.lineTo(cloff + connector + choriz + connector, ctoff+cheight/2);
        context.stroke();

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();


        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';
        context.textBaseline = 'middle';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.strokeText(String.fromCharCode(65+v), cloff + connector + 2, ctoff+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.strokeText(''+state.elems[state.currentRow][v], cloff - 2, ctoff+cvertOut+v*cvertBetween);
        }
        context.strokeStyle = '#ffffff';
        context.textAlign = 'right';
        context.strokeText('f', cloff + connector + choriz - 2, ctoff+cheight/2);
        context.strokeStyle = '#000000';
        context.textAlign = 'left';
        context.strokeText(''+state.elems[state.currentRow][state.vars], cloff + connector + choriz + connector + 2, ctoff+cheight/2);

        // Draw table...

        var rh = 30; var toff = 10; var loff = 440; var cw = 50;

        context.beginPath();
        context.strokeStyle = '#000000';
        context.rect(0, 0, canvas.width, canvas.height);
        context.stroke();

        context.beginPath();
        context.rect(loff, toff, state.elems[0].length*cw, rh);
        context.fillStyle = '#cccccc';
        context.fill();

        context.beginPath();
        context.rect(loff, toff+(state.currentRow+1)*rh, state.elems[0].length*cw, rh);
        context.fillStyle = 'yellow';
        context.fill();

        context.beginPath();
        context.lineWidth = 1;
        for(var y = 0; y <= state.elems.length+1; y++) {
          context.moveTo(loff, y*rh+toff);
          context.lineTo(loff+state.elems[0].length*cw, y*rh+toff);
        }
        for(var x = 0; x <= state.elems[0].length; x++) {
          context.moveTo(loff+x*cw, toff);
          context.lineTo(loff+x*cw, (state.elems.length+1)*rh+toff);
        }
        context.strokeStyle = '#ff0000';
        context.stroke();

        var fontSize = 14;
        context.font = 'normal '+fontSize+'pt Calibri';
        context.textAlign = 'center';
        context.textBaseline = 'bottom';
        state.hots.length = 0;

        function handler(x,y,w,h,state,row) {
          this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row;
        }

        for(var y = 0; y < state.elems.length+1; y++) {
          for(var x = 0; x < state.elems[0].length; x++) {
            var txt = y==0 ? (x<state.elems[0].length-1 ? String.fromCharCode(65+x) : 'f') : ''+state.elems[y-1][x];
            if(y>0 && x==state.elems[0].length-1) {
              txt = state.userInput[y-1];
              if(txt==-1) txt = "?";
              state.hots.push(new handler(loff+x*cw,y*rh+toff,cw,rh,state,y-1));
            }
            context.strokeText(txt, loff+(x+0.5)*cw, (y+1)*rh+toff-(rh-fontSize)/4);
          }
        }

      }

      function animate(canvas, context, state) {
        state.currentRow++;
        if(state.currentRow==state.elems.length) { state.currentRow = 0; }
        draw(canvas, context, state);
        window.setTimeout(function() {
          animate(canvas, context, state);
        }, 2000);
      }

      draw(canvas, context, state);
      window.setTimeout(function() {
        animate(canvas, context, state);
      }, 2000);

      function questionCollectUserData() {
        return {userInput: [state.userInput[0], state.userInput[1], state.userInput[2], state.userInput[3]]};
      }
    </script>

   </div>
